Package net.sf.saxon.tree.tiny

## Class TinyNodeImpl

- java.lang.Object
- - net.sf.saxon.tree.tiny.TinyNodeImpl

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `TinyAttributeImpl`, `TinyParentNodeImpl`, `TinyTextImpl`, `WhitespaceTextImpl`

      public abstract class TinyNodeImpl
      extends java.lang.Object
      implements NodeInfo

  A node in a TinyTree representing an XML element, character content, or attribute.

  This is the top-level class in the implementation class hierarchy; it essentially contains all those methods that can be defined using other primitive methods, without direct access to data.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static char[]` | `NODE_LETTER` | Characteristic letters to identify each type of node, indexed using the node type values.
    `protected int` | `nodeNr` |
    `protected TinyNodeImpl` | `parent` |
    `protected TinyTree` | `tree` |

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TinyNodeImpl()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `boolean` | `equals​(java.lang.Object other)` | The equals() method compares nodes for identity.
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `java.lang.String` | `getBaseURI()` | Get the base URI for the node.
    `int` | `getColumnNumber()` | Get the column number of the node.
    `Configuration` | `getConfiguration()` | Get the configuration
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node (a lexical QName).
    `int` | `getFingerprint()` | Get the fingerprint of the node, used for matching names
    `Genre` | `getGenre()` | Get the genre of this item
    `int` | `getLineNumber()` | Get the line number of the node within its source document entity
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `NamePool` | `getNamePool()` | Get the NamePool for the tree containing this node
    `int` | `getNodeNumber()` | Get the node number of this node within the TinyTree.
    `TinyNodeImpl` | `getParent()` | Find the parent node of this node.
    `java.lang.String` | `getPrefix()` | Get the prefix part of the name of this node.
    `NodeInfo` | `getRoot()` | Get the root node of the tree (not necessarily a document node)
    `SchemaType` | `getSchemaType()` | Get the type annotation of this node, if any.
    `protected long` | `getSequenceNumber()` | Get the node sequence number (in document order).
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `java.lang.String` | `getSystemId()` | Get the system ID for the entity containing the node.
    `TinyTree` | `getTree()` | Get the TinyTree object containing this node
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool.
    `int` | `hashCode()` | The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `NodeInfo` | `head()` | To implement `Sequence`, this method returns the item itself
    `boolean` | `isAncestorOrSelf​(TinyNodeImpl d)` | Test if this node is an ancestor-or-self of another
    `boolean` | `isId()` | Determine whether this node has the is-id property
    `boolean` | `isIdref()` | Determine whether this node has the is-idref property
    `boolean` | `isNilled()` | Determine whether the node has the is-nilled property
    `boolean` | `isSameNodeInfo​(NodeInfo other)` | Determine whether this is the same node as another node
    `boolean` | `isStreamed()` | Ask whether this is a node in a streamed document
    `AxisIterator` | `iterateAxis​(int axisNumber)` | Return an iterator over all the nodes reached by the given axis from this node
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> predicate)` | Return an iterator over the nodes reached by the given axis from this node
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `protected void` | `setParentNode​(TinyNodeImpl parent)` | Set the parent of this node.
    `void` | `setSystemId​(java.lang.String uri)` | Set the system id of this node.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, attributes, children, children, copy, getNodeKind, getPublicId, getStringValue, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Field Detail

    - #### tree

          protected TinyTree tree

    - #### nodeNr

          protected int nodeNr

    - #### parent

          protected TinyNodeImpl parent

    - #### NODE_LETTER

          public static final char[] NODE_LETTER

      Characteristic letters to identify each type of node, indexed using the node type values. These are used as the initial letter of the result of generate-id()

  - ### Constructor Detail

    - #### TinyNodeImpl

          public TinyNodeImpl()

  - ### Method Detail

    - #### getGenre

          public Genre getGenre()

      Get the genre of this item
      Specified by:
        `getGenre` in interface `Item`
      Specified by:
        `getGenre` in interface `NodeInfo`
      Returns:
        the genre

    - #### getTreeInfo

          public TreeInfo getTreeInfo()

      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Returns:
        the TreeInfo
      Since:
        9.7

    - #### head

          public NodeInfo head()

      To implement `Sequence`, this method returns the item itself
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Item`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        this item

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### getColumnNumber

          public int getColumnNumber()

      Get the column number of the node. The default implementation returns -1, meaning unknown
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the column number of the node in its original source document; or -1 if not available. The default implementation returns -1.

    - #### setSystemId

          public void setSystemId​(java.lang.String uri)

      Set the system id of this node.

      This method is present to ensure that the class implements the javax.xml.transform.Source interface, so a node can be used as the source of a transformation.

      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`

    - #### setParentNode

          protected void setParentNode​(TinyNodeImpl parent)

      Set the parent of this node. Providing this information is useful, if it is known, because otherwise getParent() has to search backwards through the document.
      Parameters:
        `parent` - the parent of this node

    - #### isSameNodeInfo

          public boolean isSameNodeInfo​(NodeInfo other)

      Determine whether this is the same node as another node
      Specified by:
        `isSameNodeInfo` in interface `NodeInfo`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this Node object and the supplied Node object represent the same node in the tree.

    - #### equals

          public boolean equals​(java.lang.Object other)

      The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().
      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
      Since:
        8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

    - #### hashCode

          public int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Specified by:
        `hashCode` in interface `NodeInfo`
      Overrides:
        `hashCode` in class `java.lang.Object`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the system ID for the entity containing the node.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Get the base URI for the node. Default implementation for child nodes gets the base URI of the parent node.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

    - #### getLineNumber

          public int getLineNumber()

      Get the line number of the node within its source document entity
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number of the node in its original source document; or -1 if not available. The default implementation returns -1.

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### getSequenceNumber

          protected long getSequenceNumber()

      Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. The sequence number must be unique within the document (not, as in previous releases, within the whole document collection). For document nodes, elements, text nodes, comment nodes, and PIs, the sequence number is a long with the sequential node number in the top half and zero in the bottom half. The bottom half is used only for attributes and namespace.
      Returns:
        the sequence number

    - #### compareOrder

          public final int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### hasFingerprint

          public final boolean hasFingerprint()

      Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool. If the answer is true, then the `getFingerprint()` method must return the fingerprint of the node. If the answer is false, then the `getFingerprint()` method should throw an `UnsupportedOperationException`. In the case of unnamed nodes such as text nodes, the result can be either true (in which case getFingerprint() should return -1) or false (in which case getFingerprint may throw an exception).
      Specified by:
        `hasFingerprint` in interface `NodeInfo`
      Returns:
        true if the implementation of this node provides fingerprints.
      Since:
        9.8; previously Saxon relied on using `FingerprintedNode` as a marker interface.

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the node, used for matching names
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix part of the name of this node. This is the name before the ":" if any.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        the prefix part of the name. For an unnamed node, return "".

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for an element or attribute in the default namespace, return an empty string.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node (a lexical QName). For elements and attributes this is [prefix:]localname. The original prefix is retained. For unnamed nodes, the result is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local part of the name of this node.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        The local name of this node. For a node with no name, return "".

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber)

      Return an iterator over all the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - Identifies the required axis, eg. Axis.CHILD or Axis.PARENT
      Returns:
        a AxisIteratorImpl that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber,
                                          java.util.function.Predicate<? super NodeInfo> predicate)

      Return an iterator over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - Identifies the required axis, eg. Axis.CHILD or Axis.PARENT
        `predicate` - A condition to be matched by the returned nodes.
      Returns:
        a AxisIteratorImpl that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### getParent

          public TinyNodeImpl getParent()

      Find the parent node of this node.
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        The Node object describing the containing element or root node.

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        `true` if this node has any attributes, `false` otherwise.

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node of the tree (not necessarily a document node)
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the root of this tree

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration
      Specified by:
        `getConfiguration` in interface `NodeInfo`
      Returns:
        the Configuration to which the tree belongs. The default implementation invokes `getTreeInfo().getConfiguration()`.

    - #### getNamePool

          public NamePool getNamePool()

      Get the NamePool for the tree containing this node
      Returns:
        the NamePool

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of objects representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace binding objects (essentially prefix/uri pairs) If the URI is "", then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - buffer, which on return will contain a character string that uniquely identifies this node.

    - #### isAncestorOrSelf

          public boolean isAncestorOrSelf​(TinyNodeImpl d)

      Test if this node is an ancestor-or-self of another
      Parameters:
        `d` - the putative descendant-or-self node
      Returns:
        true if this node is an ancestor-or-self of d

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Determine whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute

    - #### isNilled

          public boolean isNilled()

      Determine whether the node has the is-nilled property
      Specified by:
        `isNilled` in interface `NodeInfo`
      Returns:
        true if the node has the is-nilled property

    - #### isStreamed

          public boolean isStreamed()

      Ask whether this is a node in a streamed document
      Specified by:
        `isStreamed` in interface `Item`
      Specified by:
        `isStreamed` in interface `NodeInfo`
      Returns:
        true if the node is in a document being processed using streaming

    - #### getTree

          public TinyTree getTree()

      Get the TinyTree object containing this node
      Returns:
        the TinyTree. Note that this may also contain other unrelated trees

    - #### getNodeNumber

          public int getNodeNumber()

      Get the node number of this node within the TinyTree. This method is intended for internal use.
      Returns:
        the internal node number